/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 
 */
@ApiModel(description = "")

public class V1ListTimecardsRequest {
  /**
   * The order in which timecards are listed in the response, based on their created_at field. See [SortOrder](#type-sortorder) for possible values
   */
  public enum OrderEnum {
    DESC("DESC"),
    
    ASC("ASC");

    private String value;

    OrderEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static OrderEnum fromValue(String text) {
      for (OrderEnum b : OrderEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("order")
  private OrderEnum order = null;

  @JsonProperty("employee_id")
  private String employeeId = null;

  @JsonProperty("begin_clockin_time")
  private String beginClockinTime = null;

  @JsonProperty("end_clockin_time")
  private String endClockinTime = null;

  @JsonProperty("begin_clockout_time")
  private String beginClockoutTime = null;

  @JsonProperty("end_clockout_time")
  private String endClockoutTime = null;

  @JsonProperty("begin_updated_at")
  private String beginUpdatedAt = null;

  @JsonProperty("end_updated_at")
  private String endUpdatedAt = null;

  @JsonProperty("deleted")
  private Boolean deleted = null;

  @JsonProperty("limit")
  private Integer limit = null;

  @JsonProperty("batch_token")
  private String batchToken = null;

  public V1ListTimecardsRequest order(OrderEnum order) {
    this.order = order;
    return this;
  }

   /**
   * The order in which timecards are listed in the response, based on their created_at field. See [SortOrder](#type-sortorder) for possible values
   * @return order
  **/
  @ApiModelProperty(value = "The order in which timecards are listed in the response, based on their created_at field. See [SortOrder](#type-sortorder) for possible values")
  public OrderEnum getOrder() {
    return order;
  }

  public void setOrder(OrderEnum order) {
    this.order = order;
  }

  public V1ListTimecardsRequest employeeId(String employeeId) {
    this.employeeId = employeeId;
    return this;
  }

   /**
   * If provided, the endpoint returns only timecards for the employee with the specified ID.
   * @return employeeId
  **/
  @ApiModelProperty(value = "If provided, the endpoint returns only timecards for the employee with the specified ID.")
  public String getEmployeeId() {
    return employeeId;
  }

  public void setEmployeeId(String employeeId) {
    this.employeeId = employeeId;
  }

  public V1ListTimecardsRequest beginClockinTime(String beginClockinTime) {
    this.beginClockinTime = beginClockinTime;
    return this;
  }

   /**
   * If filtering results by their clockin_time field, the beginning of the requested reporting period, in ISO 8601 format.
   * @return beginClockinTime
  **/
  @ApiModelProperty(value = "If filtering results by their clockin_time field, the beginning of the requested reporting period, in ISO 8601 format.")
  public String getBeginClockinTime() {
    return beginClockinTime;
  }

  public void setBeginClockinTime(String beginClockinTime) {
    this.beginClockinTime = beginClockinTime;
  }

  public V1ListTimecardsRequest endClockinTime(String endClockinTime) {
    this.endClockinTime = endClockinTime;
    return this;
  }

   /**
   * If filtering results by their clockin_time field, the end of the requested reporting period, in ISO 8601 format.
   * @return endClockinTime
  **/
  @ApiModelProperty(value = "If filtering results by their clockin_time field, the end of the requested reporting period, in ISO 8601 format.")
  public String getEndClockinTime() {
    return endClockinTime;
  }

  public void setEndClockinTime(String endClockinTime) {
    this.endClockinTime = endClockinTime;
  }

  public V1ListTimecardsRequest beginClockoutTime(String beginClockoutTime) {
    this.beginClockoutTime = beginClockoutTime;
    return this;
  }

   /**
   * If filtering results by their clockout_time field, the beginning of the requested reporting period, in ISO 8601 format.
   * @return beginClockoutTime
  **/
  @ApiModelProperty(value = "If filtering results by their clockout_time field, the beginning of the requested reporting period, in ISO 8601 format.")
  public String getBeginClockoutTime() {
    return beginClockoutTime;
  }

  public void setBeginClockoutTime(String beginClockoutTime) {
    this.beginClockoutTime = beginClockoutTime;
  }

  public V1ListTimecardsRequest endClockoutTime(String endClockoutTime) {
    this.endClockoutTime = endClockoutTime;
    return this;
  }

   /**
   * If filtering results by their clockout_time field, the end of the requested reporting period, in ISO 8601 format.
   * @return endClockoutTime
  **/
  @ApiModelProperty(value = "If filtering results by their clockout_time field, the end of the requested reporting period, in ISO 8601 format.")
  public String getEndClockoutTime() {
    return endClockoutTime;
  }

  public void setEndClockoutTime(String endClockoutTime) {
    this.endClockoutTime = endClockoutTime;
  }

  public V1ListTimecardsRequest beginUpdatedAt(String beginUpdatedAt) {
    this.beginUpdatedAt = beginUpdatedAt;
    return this;
  }

   /**
   * If filtering results by their updated_at field, the beginning of the requested reporting period, in ISO 8601 format.
   * @return beginUpdatedAt
  **/
  @ApiModelProperty(value = "If filtering results by their updated_at field, the beginning of the requested reporting period, in ISO 8601 format.")
  public String getBeginUpdatedAt() {
    return beginUpdatedAt;
  }

  public void setBeginUpdatedAt(String beginUpdatedAt) {
    this.beginUpdatedAt = beginUpdatedAt;
  }

  public V1ListTimecardsRequest endUpdatedAt(String endUpdatedAt) {
    this.endUpdatedAt = endUpdatedAt;
    return this;
  }

   /**
   * If filtering results by their updated_at field, the end of the requested reporting period, in ISO 8601 format.
   * @return endUpdatedAt
  **/
  @ApiModelProperty(value = "If filtering results by their updated_at field, the end of the requested reporting period, in ISO 8601 format.")
  public String getEndUpdatedAt() {
    return endUpdatedAt;
  }

  public void setEndUpdatedAt(String endUpdatedAt) {
    this.endUpdatedAt = endUpdatedAt;
  }

  public V1ListTimecardsRequest deleted(Boolean deleted) {
    this.deleted = deleted;
    return this;
  }

   /**
   * If true, only deleted timecards are returned. If false, only valid timecards are returned.If you don't provide this parameter, both valid and deleted timecards are returned.
   * @return deleted
  **/
  @ApiModelProperty(value = "If true, only deleted timecards are returned. If false, only valid timecards are returned.If you don't provide this parameter, both valid and deleted timecards are returned.")
  public Boolean getDeleted() {
    return deleted;
  }

  public void setDeleted(Boolean deleted) {
    this.deleted = deleted;
  }

  public V1ListTimecardsRequest limit(Integer limit) {
    this.limit = limit;
    return this;
  }

   /**
   * The maximum integer number of employee entities to return in a single response. Default 100, maximum 200.
   * @return limit
  **/
  @ApiModelProperty(value = "The maximum integer number of employee entities to return in a single response. Default 100, maximum 200.")
  public Integer getLimit() {
    return limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }

  public V1ListTimecardsRequest batchToken(String batchToken) {
    this.batchToken = batchToken;
    return this;
  }

   /**
   * A pagination cursor to retrieve the next set of results for your original query to the endpoint.
   * @return batchToken
  **/
  @ApiModelProperty(value = "A pagination cursor to retrieve the next set of results for your original query to the endpoint.")
  public String getBatchToken() {
    return batchToken;
  }

  public void setBatchToken(String batchToken) {
    this.batchToken = batchToken;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    V1ListTimecardsRequest v1ListTimecardsRequest = (V1ListTimecardsRequest) o;
    return Objects.equals(this.order, v1ListTimecardsRequest.order) &&
        Objects.equals(this.employeeId, v1ListTimecardsRequest.employeeId) &&
        Objects.equals(this.beginClockinTime, v1ListTimecardsRequest.beginClockinTime) &&
        Objects.equals(this.endClockinTime, v1ListTimecardsRequest.endClockinTime) &&
        Objects.equals(this.beginClockoutTime, v1ListTimecardsRequest.beginClockoutTime) &&
        Objects.equals(this.endClockoutTime, v1ListTimecardsRequest.endClockoutTime) &&
        Objects.equals(this.beginUpdatedAt, v1ListTimecardsRequest.beginUpdatedAt) &&
        Objects.equals(this.endUpdatedAt, v1ListTimecardsRequest.endUpdatedAt) &&
        Objects.equals(this.deleted, v1ListTimecardsRequest.deleted) &&
        Objects.equals(this.limit, v1ListTimecardsRequest.limit) &&
        Objects.equals(this.batchToken, v1ListTimecardsRequest.batchToken);
  }

  @Override
  public int hashCode() {
    return Objects.hash(order, employeeId, beginClockinTime, endClockinTime, beginClockoutTime, endClockoutTime, beginUpdatedAt, endUpdatedAt, deleted, limit, batchToken);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class V1ListTimecardsRequest {\n");
    
    sb.append("    order: ").append(toIndentedString(order)).append("\n");
    sb.append("    employeeId: ").append(toIndentedString(employeeId)).append("\n");
    sb.append("    beginClockinTime: ").append(toIndentedString(beginClockinTime)).append("\n");
    sb.append("    endClockinTime: ").append(toIndentedString(endClockinTime)).append("\n");
    sb.append("    beginClockoutTime: ").append(toIndentedString(beginClockoutTime)).append("\n");
    sb.append("    endClockoutTime: ").append(toIndentedString(endClockoutTime)).append("\n");
    sb.append("    beginUpdatedAt: ").append(toIndentedString(beginUpdatedAt)).append("\n");
    sb.append("    endUpdatedAt: ").append(toIndentedString(endUpdatedAt)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    batchToken: ").append(toIndentedString(batchToken)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

